﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sfgrid_sample
{
    public class OrderInfo:INotifyPropertyChanged
    {
        int? orderID;
        string customerId;
        string country;
        string customerName;
        string shippingCity;
        double? unitPrice;
        int quantity;
        double discount;
        string contactNumber;
        TimeSpan? deliveryTime;
        DateTime? orderDate;
        bool isdelivered;
        string productName;

        public string ProductName
        {
            get { return productName; }
            set { productName = value; }
        }
        Uri link = new Uri("https://Google.com/");
        public Uri Link
        {
            get { return link; }
            set { link = value; }
        }
        public bool IsDelivered
        {
            get { return isdelivered; }
            set { isdelivered = value; }
        }
        //[Display(AutoGenerateField = false, Description = "OrderID field is not generated in UI")]
        //[Display(Order=0)]
        //[Bindable(false)]
        public int? OrderID
        {
            get { return orderID; }
            set { orderID = value; }
        }

        //[Display(AutoGenerateFilter = true, Description = "Filter enabled for CustomerID column")]
        [Display(Order=-1)]
        public string CustomerID
        {
            get { return customerId; }
            set { customerId = value; }
        }
        ////[Display(Name="Name of the Customer",Description="CustomerName is necessary for identification ")]
        public string CustomerName
        {
            get { return customerName; }
            set { customerName = value; }
        }
        //[Editable(true)]
        //[ReadOnly(true)]
        public string Country
        {
            get { return country; }
            set { country = value; }
        }

        public string ShipCity
        {
            get { return shippingCity; }
            set { shippingCity = value; }
        }
        //[DataType(DataType.Currency)]        
        public double?  UnitPrice
        {
            get { return unitPrice; }
            set { unitPrice = value; }
        }

        public int Quantity
        {
            get { return quantity; }
            set { quantity = value; }
        }

        public double Discount
        {
            get { return discount; }
            set { discount = value; }
        }
        public string ContactNumber
        {
            get { return contactNumber; }
            set { contactNumber = value; }
        }

        public TimeSpan? DeliveryTime
        {
            get { return deliveryTime; }
            set { deliveryTime = value; }
        }

        public DateTime? OrderDate
        {
            get { return orderDate; }
            set { orderDate = value; }
        }
        public OrderInfo(int? orderId, string customerName, string country, string customerId, string shipCity,double? unitprice,int quantity,double discount ,string cno,TimeSpan? deliverydelay,DateTime? orderdate,bool isdelivered,string productname)
        {
            this.OrderID = orderId;
            this.CustomerName = customerName;
            this.Country = country;
            this.CustomerID = customerId;
            this.ShipCity = shipCity;
            this.UnitPrice = unitprice;
            this.Quantity = quantity;
            this.Discount = discount;
            this.ContactNumber = cno;
            this.DeliveryTime = deliverydelay;
            this.OrderDate = orderdate;
            this.IsDelivered = isdelivered;
            this.ProductName = productname;
        }
       
        public event PropertyChangedEventHandler PropertyChanged;
        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
    }
}
